#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <curl/curl.h>

#define OK "200 OK\r\n"

size_t write_callback(char *ptr, size_t size, size_t nmemb, void *userdata) {
    return nmemb;
}

size_t header_callback(char *buffer, size_t size, size_t nitems, void *userdata) {
    if (nitems > strlen(OK) && strncmp(&buffer[nitems - strlen(OK)], OK, strlen(OK)) == 0) {
        printf("%.*s", (int)nitems, buffer);
    }
    return nitems;
}

int main(int argc, char* argv[]) {
    if (curl_global_init(CURL_GLOBAL_ALL) != CURLE_OK) {
        return 1;
    }

    printf("%s\n", curl_version());

    CURLcode res;
    CURL *curl = curl_easy_init();
    if (curl == NULL) {
        return 1;
    }

    struct curl_blob root_cert;
    root_cert.data = NULL;
    root_cert.len = 0;
    curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_callback);
    curl_easy_setopt(curl, CURLOPT_HEADERFUNCTION, header_callback);
    curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER, 0);
    curl_easy_setopt(curl, CURLOPT_CAINFO_BLOB, &root_cert);
    curl_easy_setopt(curl, CURLOPT_URL, "https://www.google.com:443");
    res = curl_easy_perform(curl);
    if (res != CURLE_OK) {
        printf("curl_easy_perform returned %d\n%s\n", res, curl_easy_strerror(res));
    }

    curl_easy_cleanup(curl);
    return 0;
}
